OLDC.CVars = {}

local F = OLDC.Functions
local CV = OLDC.CVars

local function returnToHub(player, str)
	if str and str:lower() == "yes"
		-- There is no reason why any of these should be kept between maps,
		-- but alas
		player.starpostx = 0
		player.starposty = 0
		player.starpostz = 0
		player.starpostnum = 0
		player.starposttime = 0
		player.starpostangle = 0
		player.starpostscale = FRACUNIT
		
		player.pflags = $ | PF_NOCLIP -- So the player doesn't touch a starpost midtransition
		
		F.FailLevel()
		F.ExitLevel(OLDC.hub, 2)
	else
		CONS_Printf(player, "Type \"abortlevel yes\" to quit the current entry, and return to the contest hub.")
	end
end

COM_AddCommand("abortlevel", returnToHub, COM_ADMIN)

local function returnSpecialCVarValue(cvar)
	if cvar == "nolives"
		if modeattacking or not G_GametypeUsesLives()
			return 0
		else
			return CV.nolives.value
		end
	end
end

local function resetLives()
	if returnSpecialCVarValue("nolives")
		F.DEShortcut("lives", false)
		
		OLDC.Data.nolives = true
		return 
	end
	
	if not G_GametypeUsesLives() return end
	if modeattacking return end
	if marathonmode return end
	
	OLDC.Data.nolives = false
	F.DEShortcut("lives", true)
	
	for p in players.iterate
		if p.bot continue end
		
		p.lives = 5 -- yes cheaty
	end
end

CV.vote = CV_RegisterVar({
	name = "oldc_votetime",
	defaultvalue = "10",
	flags = CV_SAVE|CV_NETVAR,
	PossibleValue = {MIN = -1, MAX = 3600}
})

CV.pick = CV_RegisterVar({
	name = "oldc_whopicks",
	defaultvalue = "All",
	flags = CV_SAVE|CV_NETVAR|CV_SHOWMODIF,
	PossibleValue = {All = 0, Host = 1}
})

CV.nolives = CV_RegisterVar({
	name = "oldc_nolives",
	defaultvalue = "On",
	flags = CV_CALL|CV_NETVAR|CV_NOINIT|CV_SHOWMODIF, -- CV_CHEAT?
	PossibleValue = CV_OnOff,
	func = resetLives
})